<template>
    <v-app>
        <v-main>
            <v-card class="mx-auto" max-width="769" outlined>
                <v-list-item three-line>
                    <v-list-item-content>
                        <div class="overline mb-4">
                            <img src="@/assets/logo.png" />
                        </div>

                        <div v-if="!sent">
                            <v-list-item-title class="headline mb-1"
                                >Como foi sua experiência?</v-list-item-title
                            >
                            <v-list-item-subtitle
                                >Compartilhe conosco para construirmos juntos o
                                melhor serviço do mundo.</v-list-item-subtitle
                            >
                            <profissionalRating @input="changeRating" />
                            <platformRating
                                @input="changeRating"
                                area="platform"
                            />

                            <span class="mt-4"
                                >Uma escala medindo de 0 a 10. Você indicaria
                                nosso produto?
                            </span>
                            <v-list-item-subtitle
                                >0 é uma opinião extremamente insatisfeita e 10
                                significa que o você está muito satisfeito.
                            </v-list-item-subtitle>
                            <div class="row">
                                <div class="col">
                                    <v-chip
                                        style="cursor: pointer"
                                        :color="getColorIndicator(item)"
                                        v-for="(item, key) in 11"
                                        @click="
                                            indicator.value = item;
                                            indicator.lock = true;
                                        "
                                        v-bind:key="item"
                                        class="ma-2"
                                    >
                                        {{ key }}
                                    </v-chip>
                                </div>
                            </div>
                            <div class="my-2 text-center">
                                <v-btn
                                    depressed
                                    :loading="isLoading"
                                    @click="sendSurvey()"
                                    :disabled="
                                        rating.platform == 0 ||
                                            rating.profissional == 0
                                    "
                                    color="primary"
                                    >Enviar</v-btn
                                >
                            </div>
                        </div>
                        <div v-else>
                            <v-alert outlined type="success" text>
                                <p>Sua opinião é muito valiosa</p>

                                <p>
                                    Agradecemos pelo tempo dispensado e pelo seu
                                    feedback!
                                </p>
                                <p>Equipe Conexa Saúde</p>
                            </v-alert>
                        </div>
                    </v-list-item-content>
                </v-list-item>
            </v-card>
        </v-main>
    </v-app>
</template>

<script>
import profissionalRating from "./components/rating";
import platformRating from "./components/rating";
export default {
    name: "App",
    components: {
        profissionalRating,
        platformRating,
    },

    data: () => ({
        isLoading: false,
        sent: false,
        rating: {
            profissional: 0,
            platform: 0,
        },
        indicator: {
            value: 0,
            lock: false,
        },
    }),
    computed: {
        indicatorRateValue() {
            if (this.indicator.lock) {
                return this.indicator.value;
            }
            return this.rating.profissional + this.rating.platform + 1;
        },
    },
    methods: {
        changeRating(ratingObject) {
            this.rating[ratingObject.area] = ratingObject.rate;
        },
        getColorIndicator(actualRate) {
            let color;
            let rate = this.indicatorRateValue;
            switch (true) {
                case rate < 3:
                    color = "red";
                    break;
                case rate >= 3 && rate <= 5:
                    color = "warning";
                    break;
                case rate >= 6:
                    color = "success";
                    break;
            }
            if (actualRate > rate || rate == 1) {
                color = "";
            }
            return color;
        },
        sendSurvey() {
            this.isLoading = true;

            setTimeout(() => {
                this.isLoading = false;
                this.sent = true;
            }, 1200);
        },
    },
};
</script>

<style lang="scss">
.red > span {
    color: white;
}
</style>
